<template>
  <main>
    <!-- Header -->
    <div class="row row-xs items-center">
      <div class="col">
        <h1>User Management</h1>
      </div>
      <div class="col-auto">
        <form @submit.prevent="handleSearchUser">
          <b-input
            v-model="searchParams.SearchString"
            class="w-max-240"
            placeholder="Search"
            clearable
            @input="handleSearchUser"
          >
            <b-button-icon
              slot="append"
              native-type="submit"
              primary
              ghost
              name="search"
            />
          </b-input>
        </form>
      </div>
      <div class="col-auto">
        <b-button-group>
          <b-button-text
            small
            prefix-icon="user-connect"
            @click.prevent="AddUserModal"
            >New User</b-button-text
          >
          <b-button-text
            v-popover:filterPanel
            small
            prefix-icon="filter"
            :class="{ active: filteringOptionsVisible }"
            @click.prevent="filteringOptionsVisible = !filteringOptionsVisible"
            >Filter</b-button-text
          >
          <b-dropdown
            trigger="click"
            @command="handleSortCommand"
            @visible-change="(value) => (sortPanelVisible = value)"
          >
            <b-button-text
              small
              :prefix-icon="
                (usersOrderBy.order === 'desc' && 'sort-down') ||
                (usersOrderBy.order === 'asc' && 'sort-up') ||
                'sort'
              "
              :class="{ active: sortPanelVisible }"
              @click.capture="filteringOptionsVisible = false"
              >Sort by</b-button-text
            >
            <b-dropdown-menu slot="dropdown" class="w-min-200">
              <b-dropdown-item
                :class="{
                  'c-primary-3': usersSearchParams.OrderBy === 'updatedAt desc',
                }"
                icon="sort-latest-down"
                :command="{ field: 'updatedAt', order: 'desc' }"
              >
                <span class="d-flex items-center">
                  <span>Latest</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Oldest</span>
                </span>
              </b-dropdown-item>
              <b-dropdown-item
                :class="{
                  'c-primary-3': usersSearchParams.OrderBy === 'updatedAt asc',
                }"
                icon="sort-latest-up"
                :command="{ field: 'updatedAt', order: 'asc' }"
              >
                <span class="d-flex items-center">
                  <span>Oldest</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Latest</span>
                </span>
              </b-dropdown-item>
              <b-dropdown-item
                :class="{
                  'c-primary-3': usersSearchParams.OrderBy === 'fullName asc',
                }"
                icon="sort-alphabet-down"
                :command="{ field: 'fullName', order: 'asc' }"
              >
                <span class="d-flex items-center">
                  <span>Ascending</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Descending</span>
                </span>
              </b-dropdown-item>
              <b-dropdown-item
                :class="{
                  'c-primary-3': usersSearchParams.OrderBy === 'fullName desc',
                }"
                icon="sort-alphabet-up"
                :command="{ field: 'fullName', order: 'desc' }"
              >
                <span class="d-flex items-center">
                  <span>Descending</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Ascending</span>
                </span>
              </b-dropdown-item>
            </b-dropdown-menu>
          </b-dropdown>
        </b-button-group>
      </div>
      <!-- <div class="col-auto">
        <b-tooltip content="View mode" placement="top" effect="light">
          <b-button-icon :name="viewModeName" @click.prevent="handleViewMode" />
        </b-tooltip>
      </div> -->
    </div>
    <b-divider class="mt-6x" />
    <b-popover
      ref="filterPanel"
      v-model="filteringOptionsVisible"
      placement="bottom-end"
      trigger="manual"
      :width="320"
    >
      <b-form-item :label="$t('vuelidate.fields.status')" topless>
        <b-select v-model="searchParams.Status" filterable placeholder="Select">
          <b-option
            v-for="status in statuses"
            :key="status.key"
            :value="status.key"
            :label="status.value"
          />
        </b-select>
      </b-form-item>

      <div class="d-flex content-end mt-6x">
        <b-button @click.prevent="handleUserFilterCancel">Cancel</b-button>
        <b-button primary class="ml-2x" @click.prevent="handleFilterUsers"
          >Apply</b-button
        >
      </div>
    </b-popover>

    <!-- Filtering options -->
    <div v-if="usersParamsTouched" class="row row-xs items-center mt-6x">
      <div v-if="usersSearchParams.Status !== ''" class="col-auto">
        <common-filtered-item
          title="Status"
          @clear="handleClearFilteredParam('Status', '')"
        >
          {{
            statuses.find((item) => item.key === usersSearchParams.Status).value
          }}
        </common-filtered-item>
      </div>
      <div class="col-auto">
        <b-button-text
          small
          prefix-icon="close"
          @click.prevent="handleClearAllFilteredParams"
          >Clear all</b-button-text
        >
      </div>
    </div>

    <!-- Listing -->
    <div v-if="users.total > 0">
      <b-card class="mt-6x">
        <div class="row">
          <div
            v-for="(item, index) in users.entities"
            :key="item.id + Math.random()"
            class="col-12"
          >
            <div class="row items-center">
              <div class="col-auto">
                <b-avatar rounded :text="item.fullName" :size="88"></b-avatar>
              </div>
              <div class="col">
                <div class="row">
                  <b-divider v-if="index !== 0" class="mt-3x mb-6x" />
                  <div class="col">
                    <h2>{{ item.fullName }}</h2>
                  </div>
                  <div class="col-auto">
                    <b-button
                      rounded
                      style="font-size: 13px"
                      @click.prevent="updateUserModal(item)"
                      ><b-icon name="identity" class="mr-1x"></b-icon>Change
                      info</b-button
                    >
                  </div>
                  <div class="col-auto">
                    <b-dropdown
                      trigger="click"
                      @command="handleCommand($event, item)"
                    >
                      <b-button-icon
                        rounded
                        name="more-vertical"
                      ></b-button-icon>
                      <b-dropdown-menu slot="dropdown">
                        <b-dropdown-item
                          v-if="item.isActive"
                          danger
                          icon="deactivate"
                          command="deactivate"
                          >Disable</b-dropdown-item
                        >
                        <b-dropdown-item
                          v-else
                          icon="activate"
                          command="activate"
                          >Enable</b-dropdown-item
                        >
                      </b-dropdown-menu>
                    </b-dropdown>
                  </div>
                </div>

                <div class="row">
                  <div class="col">
                    <b-form-item :label="$t('vuelidate.fields.email')">
                      <b-form-item-text v-if="item.email"
                        >{{ item.email }}
                        <a :href="`mailto:${item.email}`">
                          <b-icon
                            xsmall
                            style="color: #19acdb; font-size: 12px"
                            name="plane"
                          ></b-icon> </a
                      ></b-form-item-text>
                      <b-form-item-text v-else>— </b-form-item-text>
                    </b-form-item>
                  </div>
                  <div class="col">
                    <b-form-item :label="$t('vuelidate.fields.contactNumber')">
                      <b-form-item-text
                        v-if="item.phoneNumber"
                        id="contact-number"
                        >{{ item.phoneNumber }}
                        <b-button-icon
                          xsmall
                          name="copy"
                          style="color: #19acdb; background: white"
                          @click.prevent="copyPhoneNumber"
                        ></b-button-icon>
                      </b-form-item-text>
                      <b-form-item-text v-else>— </b-form-item-text>
                    </b-form-item>
                  </div>

                  <div class="col">
                    <b-form-item
                      :label="$t('vuelidate.fields.registrationDate')"
                    >
                      <b-form-item-text>{{
                        item.createdAt | moment('MM/DD/YYYY HH:mm:ss')
                      }}</b-form-item-text>
                    </b-form-item>
                  </div>
                  <div class="col">
                    <b-form-item :label="$t('vuelidate.fields.status')">
                      <b-form-item-text>
                        <b-button
                          v-if="item.isActive"
                          style="font-size: 12px"
                          class="button-active"
                          small
                          rounded
                          >Enabled</b-button
                        >
                        <b-button
                          v-else
                          style="font-size: 12px"
                          class="button-deactive"
                          small
                          rounded
                          >Disabled</b-button
                        >
                      </b-form-item-text>
                    </b-form-item>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- Pagination -->
        <b-pagination
          :current-page.sync="currentPage"
          :total="users.total"
          :page-size="usersSearchParams.Length"
          class="mt-6x"
          @current-change="handleCurrentPageChange"
        ></b-pagination>
      </b-card>
    </div>

    <template v-else>
      <common-empty-state
        v-if="!usersParamsTouched"
        message="The users list is empty."
      />
      <common-search-no-results
        v-else
        title="No result"
        message="These is no records matched your search criteria."
      />
    </template>

    <!-- Additional -->
    <add-edit-user-modal
      v-if="addEditUserModalVisible"
      :entity="viewUser"
      @close="handleAddUserModalClose"
      @submit="handleAddUserModalSubmit"
    />
    <change-status-modal
      v-if="changeStatusModalVisible"
      :entity="viewUser"
      @close="handleChangeStatusClose"
      @submit="handleChangeStatusSubmit"
    />
  </main>
</template>

<script lang="ts">
import Vue from 'vue'
import { mapState, mapActions, mapGetters } from 'vuex'
import cloneDeep from 'lodash/cloneDeep'
import AddEditUserModal from '~/partials/user-management/AddEditUserModal.vue'
import ChangeStatusModal from '~/partials/user-management/ChangeStatusModal.vue'
import { UserObject, UserSearchParamsObject } from '~/models/law'

export default Vue.extend({
  name: 'UserListPage',
  components: {
    AddEditUserModal,
    ChangeStatusModal,
  },

  async asyncData({ store, error }) {
    const tasks = []
    if (store.state.law.users.entities.length === 0) {
      tasks.push(store.dispatch('law/fetchUsers'))
    }

    try {
      await Promise.all(tasks)
    } catch (e: any) {
      error(e)
    }

    return {
      searchParams: cloneDeep(store.state.law.usersSearchParams),
    }
  },
  data() {
    return {
      searchParams: {} as UserSearchParamsObject,
      searchDebound: null as any,

      currentPage: 1,
      // viewMode: 'table',
      // viewModeName: 'task-list',
      sortPanelVisible: false,
      filteringOptionsVisible: false,
      addEditUserModalVisible: false,
      changeStatusModalVisible: false,

      statuses: [
        { key: true, value: 'Enabled' },
        { key: false, value: 'Disabled' },
      ],

      viewUser: null as UserObject | null,
    }
  },
  head: {
    title: 'Users list',
  },
  meta: {
    breadcrumb: 'Users list',
  },
  computed: {
    ...mapState('law', [
      'users',
      'usersSearchParams',
      'usersCurrentPage',
      'usersOrderBy',
    ]),
    ...mapGetters('law', ['usersParamsTouched']),
  },
  created() {
    this.currentPage = this.usersCurrentPage
  },
  methods: {
    ...mapActions('law', [
      'fetchUsers',
      'setUsersCurrentPage',
      'setUsersSearchParams',
      'setUsersOrderBy',
    ]),

    async reloadData(page = 1) {
      this.searchParams.Start = this.searchParams.Length! * (page - 1)
      this.setUsersCurrentPage(page)
      await this.setUsersSearchParams(cloneDeep(this.searchParams))
    },
    handleSearchUser() {
      if (this.searchDebound) clearTimeout(this.searchDebound)
      this.searchDebound = setTimeout(() => {
        this.searchParams.SearchString =
          this.searchParams.SearchString?.trim() || ''
        this.usersSearchParams.SearchString !==
          this.searchParams.SearchString && this.reloadData()
      }, 500)
    },
    handleFilterUsers() {
      this.filteringOptionsVisible = false
      this.reloadData()
    },
    handleUserFilterCancel() {
      this.searchParams = cloneDeep(this.usersSearchParams)
      this.filteringOptionsVisible = false
    },
    handleClearFilteredParam(param: string, initialValue: any = '') {
      Object.assign(this.searchParams, { [param]: initialValue })
      this.reloadData()
    },
    handleClearAllFilteredParams() {
      this.searchParams.Status = ''
      this.reloadData()
    },

    handleCurrentPageChange(page: number) {
      this.reloadData(page)
    },
    handleSortCommand(orderBy: { field: string; order: string }) {
      const unsort =
        this.usersSearchParams.OrderBy === `${orderBy.field} ${orderBy.order}`

      this.searchParams.OrderBy = unsort
        ? ''
        : `${orderBy.field} ${orderBy.order}`
      this.setUsersOrderBy(
        unsort ? { field: '', order: '' } : cloneDeep(orderBy)
      )
      this.reloadData(this.currentPage)
    },
    handleCommand(command: 'activate' | 'deactivate', item: any) {
      if (command === 'activate' || command === 'deactivate') {
        this.handleUpdateStatus(item)
      }
    },

    AddUserModal() {
      this.addEditUserModalVisible = true
    },
    updateUserModal(item: UserObject) {
      this.viewUser = item
      this.addEditUserModalVisible = true
    },
    handleAddUserModalClose() {
      this.viewUser = null
      this.addEditUserModalVisible = false
    },
    handleAddUserModalSubmit() {
      this.handleAddUserModalClose()
      // this.reloadData() // reloaded on add/update
    },

    handleUpdateStatus(item: UserObject) {
      this.viewUser = item
      this.changeStatusModalVisible = true
    },
    handleChangeStatusClose() {
      this.viewUser = null
      this.changeStatusModalVisible = false
    },
    handleChangeStatusSubmit() {
      this.handleChangeStatusClose()
      this.reloadData()
    },

    copyPhoneNumber() {
      const node = document.getElementById('contact-number')
      const selection = window.getSelection()
      const range = document.createRange()

      if (node) {
        range.selectNodeContents(node)
        selection!.removeAllRanges()
        selection!.addRange(range)

        document.execCommand('copy')
        this.$message('Copied to clipboard')
      }
    },
  },
})
</script>
<style>
.button-active {
  background: #e4ffe7;
  color: #006b0f;
}
.button-active:hover {
  background: #e4ffe7;
  color: #006b0f;
}
.button-active:focus {
  background: #e4ffe7;
  color: #006b0f;
}

.button-deactive {
  background: #f5f5f5;
  color: #000000;
}
.button-deactive:hover {
  background: #f5f5f5;
  color: #000000;
}
.button-deactive:focus {
  background: #f5f5f5;
  color: #000000;
}
</style>
